
function stats()
{
  this.minhp = 0; // for ghosts
  this.hp = 100;
  this.maxhp = 125;
  this.mp = 100;
  this.maxmp = 120;
  this.str = 33;
  this.spd = 100;
  this.def = 3;
  this.luck = 10;
  this.order = 0;
  this.lvl = 3;
}

stats.prototype.clone = function()
{
  var obj = new stats();
  var i = 0;
  for(i in this)
    obj[i] = this[i];
  return obj;
}

stats.prototype.take_hp = function(value)
{
  this.hp -= value;
  if(this.hp > Math.max(this.maxhp, this.minhp)) this.hp = Math.max(this.maxhp, this.minhp);
  if(this.hp < Math.min(this.maxhp, this.minhp)) this.hp = Math.min(this.maxhp, this.minhp);
}

stats.prototype.take_mp = function(value)
{
  this.mp -= value;
  if(this.mp > this.maxmp) this.mp = this.maxmp;
  if(this.mp < 0) this.mp = 0;
}

stats.prototype.is_defeated = function()
{
  if(this.hp == this.minhp)
    return true;
  return false;
}

stats.prototype.isAbleToAttack = function()
{
  if(!this.is_defeated())
    return true;
  return false;
}

function RestoreAll() {
 for (var i = 0; i < entities.length; ++i)
   entities[i].stats.take_hp(-entities[i].stats.maxhp);
}

/////////////////////////////////////////////////

function weapon()
{
  this.name = "No weapon";
  this.power = 1;
  this.desc = "";
  this.cost = 1;
  this.amount = 1;
  this.limited = false;

  this.canAttackAlivePlayers = true;
  this.canAttackAliveMonsters = true;
  this.canAttackAliveNeutrals = true;
  this.canAttackAllAlivePlayers = true;
  this.canAttackAllAliveMonsters = true;
  this.canAttackAllAliveNeutrals = true;

  this.canAttackDeadPlayers = false;
  this.canAttackDeadMonsters = false;
  this.canAttackDeadNeutrals = false;
  this.canAttackAllDeadPlayers = false;
  this.canAttackAllDeadMonsters = false;
  this.canAttackAllDeadNeutrals = false;

  this.canAttackAllAlive = false;
  this.canAttackAllDead = false;
  this.canAttackAll = false;

  this.addOrder = new Array("AttackAliveMonsters", "AttackAlivePlayers", "AttackAliveNeutrals", "AttackAllAliveMonsters", "AttackAllAlivePlayers", "AttackAllAliveNeutrals", "AttackAllAlive", "AttackAllDead", "AttackAll");
}

weapon.prototype.getUseableOnIndexArray = function()
{
  var tmp = new Array();

  for(var j = 0; j < this.addOrder.length; ++j)
  {
    switch(this.addOrder[j])
    {
      case "AttackAliveMonsters": {
        for(var i = 0; i < entities.length; ++i)
        {
          if(this.canAttackAliveMonsters && !entities[i].stats.is_defeated() && entities[i].type == "monster")
            tmp.push([i]);
        }
        break;
      }

      case "AttackAlivePlayers": {
        for(var i = 0; i < entities.length; ++i)
        {
          if(this.canAttackAlivePlayers && !entities[i].stats.is_defeated() && entities[i].type == "player")
            tmp.push([i]);
        }
        break;
      }

      case "AttackAliveNeutrals": {
        for(var i = 0; i < entities.length; ++i)
        {
          if(this.canAttackAliveNeutrals && !entities[i].stats.is_defeated() && entities[i].type == "neutral")
            tmp.push([i]);
        }
        break;
      }

      case "AttackDeadMonsters": {
        for(var i = 0; i < entities.length; ++i)
        {
          if(this.canAttackDeadMonsters && entities[i].stats.is_defeated() && entities[i].type == "monster")
            tmp.push([i]);
        }
        break;
      }

      case "AttackDeadPlayers": {
        for(var i = 0; i < entities.length; ++i)
        {
          if(this.canAttackDeadPlayers && entities[i].stats.is_defeated() && entities[i].type == "player")
            tmp.push([i]);        
        }
        break;
      }

      case "AttackDeadNeutrals": {
        for(var i = 0; i < entities.length; ++i)
        {
          if(this.canAttackDeadNeutrals && entities[i].stats.is_defeated() && entities[i].type == "neutral")
            tmp.push([i]);
        }
        break;
      }

      case "AttackAllAliveMonsters": {
        if(this.canAttackAllAliveMonsters && GetAliveMonstersIndexArray().length > 1)
          tmp.push(GetAliveMonstersIndexArray());
        break;
      }

      case "AttackAllAlivePlayers": {
       if(this.canAttackAllAlivePlayers && GetAlivePlayersIndexArray().length > 1)
          tmp.push(GetAlivePlayersIndexArray());
        break;
      }
      
      case "AttackAllAliveNeutrals": {
        if(this.canAttackAllAliveNeutrals && GetAliveNeutralsIndexArray().length > 1)
          tmp.push(GetAliveNeutralsIndexArray());
        break;
      }

      case "AttackAllDeadPlayers": {
        if(this.canAttackAllDeadPlayers && GetDeadPlayersIndexArray().length > 1)
          tmp.push(GetDeadPlayersIndexArray());
        break;
      }

      case "AttackAllDeadMonsters": {
        if(this.canAttackAllDeadMonsters && GetDeadMonstersIndexArray().length > 1)
          tmp.push(GetDeadMonstersIndexArray());
       break;
      }

      case "AttackAllDeadNeutrals": {
        if(this.canAttackAllDeadNeutrals && GetDeadNeutralsIndexArray().length > 1)
          tmp.push(GetDeadNeutralsIndexArray());
        break;
      }

      case "AttackAllAlive": {
        if(this.canAttackAllAlive && GetAllAliveEntitiesIndexArray().length > 0)
          tmp.push(GetAllAliveEntitiesIndexArray());
        break;
      }

      case "AttackAllDead": {
        if(this.canAttackAllDead && GetAllDeadEntitiesIndexArray().length > 0)
          tmp.push(GetAllDeadEntitiesIndexArray());
       break;
      }

      case "AttackAll": {
        if(this.canAttackAll && GetAllEntitiesIndexArray().length > 0)
          tmp.push(GetAllEntitiesIndexArray());
        break;
      }
    }
  }

  return tmp;
}


weapon.prototype.clone = function()
{
  var obj = new weapon();
  var i = 0;
  for(i in this)
    obj[i] = this[i];
  return obj;
}

weapon.prototype.is_equipable_by = function(who)
{
  return true;
}

weapon.prototype.on_equip = function(who)
{
  if (this.is_equipable_by(who))
  {
    entities[who].weapon = this.clone();
  }
}

weapon.prototype.on_unequip = function()
{
  return true;
}

weapon.prototype.has_some = function(fromWho)
{
  if (!this.limited || this.amount > 0)
    return true;
  return false;
}

function GiveWeapon(weapon)
{ // weapon object as parameter
  var found = false;
  for (var i = 0; i < party_weapons.length; ++i)
  {
    if (party_weapons[i].name == weapon.name) {
      party_weapons[i].amount += weapon.amount;
      found = true;
      break;
    }
  }
  if (!found)
    party_weapons.push(weapon.clone());  
}

/////////////////////////////////////////////////

function item(name, desc, amount, cost)
{
  this.name = name;
  this.desc = desc;
  this.amount = amount;
  this.cost = cost;
  this.power = 1;
  this.limited = true;
  this.important = false; // you could sell it

  this.useable_outside_battle = true;
  this.useable_in_battle = true;

  this.canAttackAlivePlayers = true;
  this.canAttackAliveMonsters = true;
  this.canAttackAliveNeutrals = true;
  this.canAttackDeadPlayers = false;
  this.canAttackDeadMonsters = false;
  this.canAttackDeadNeutrals = false;

  this.canAttackAllAlivePlayers = true;
  this.canAttackAllAliveMonsters = true;
  this.canAttackAllAliveNeutrals = true;
  this.canAttackAllDeadPlayers = false;
  this.canAttackAllDeadMonsters = false;
  this.canAttackAllDeadNeutrals = false;

  this.canAttackAllAlive = false;
  this.canAttackAllDead = false;
  this.canAttackAll = false;

  this.use = function(fromWho, onWho) {}

  this.addOrder = new Array("AttackAlivePlayers", "AttackAliveMonsters", "AttackAliveNeutrals", "AttackAllAlivePlayers", "AttackAllAliveMonsters", "AttackAllAliveNeutrals", "AttackAllAlive", "AttackAllDead", "AttackAll");
}

item.prototype.getUseableOnIndexArray = weapon.prototype.getUseableOnIndexArray;

item.prototype.clone = function()
{
  var obj = new item();
  var i = 0;
  for(i in this)
    obj[i] = this[i];
  return obj;
}

item.prototype.onUseOutsideBattle = function(fromWho, onWho)
{
  this.on_use(fromWho, onWho);
}

item.prototype.on_use = function(fromWho, onWho)
{
  if(this.has_some(fromWho))
  {
    this.use(fromWho, onWho);
    if (this.limited)
      this.amount -= 1;
  }
}

item.prototype.onUseInBattle = function(fromWho, onWho)
{
  this.on_use(fromWho, onWho);
}

item.prototype.has_some = function(fromWho)
{
  if (!this.limited || this.amount > 0)
    return true;
  return false;
}

function GetItemIndex(name)
{
  for (var i = 0; i < party_items.length; ++i)
    if (party_items[i].name == name)
      return i;
  return -1;
}

function GiveItem(item)
{ // item object as parameter
  var found = false;
  for (var i = 0; i < party_items.length; ++i)
  {
    if (party_items[i].name == item.name) {
      party_items[i].amount += item.amount;
      found = true;
      break;
    }
  }
  if (!found)
    party_items.push(item.clone());  
}

/////////////////////////////////////////////////

function spell(name, desc, amount, cost)
{
  this.name = name;
  this.desc = desc;
  this.amount = amount;
  this.cost = cost;

  this.mp_cost = 1;
  this.power = 1;

  this.useable_outside_battle = false;
  this.useable_in_battle = true;

  this.canAttackAlivePlayers = true;
  this.canAttackAliveMonsters = true;
  this.canAttackAliveNeutrals = true;
  this.canAttackDeadPlayers = false;
  this.canAttackDeadMonsters = false;
  this.canAttackDeadNeutrals = false;

  this.canAttackAllAlivePlayers = true;
  this.canAttackAllAliveMonsters = true;
  this.canAttackAllAliveNeutrals = true;
  this.canAttackAllDeadPlayers = false;
  this.canAttackAllDeadMonsters = false;
  this.canAttackAllDeadNeutrals = false;

  this.canAttackAllAlive = false;
  this.canAttackAllDead = false;
  this.canAttackAll = false;

  this.use = function(fromWho, onWho) {}
  this.limited = true;
  this.addOrder = new Array("AttackAlivePlayers", "AttackAliveMonsters", "AttackAliveNeutrals", "AttackAllAlivePlayers", "AttackAllAliveMonsters", "AttackAllAliveNeutrals", "AttackAllAlive", "AttackAllDead", "AttackAll");
}

spell.prototype.getUseableOnIndexArray = weapon.prototype.getUseableOnIndexArray;

spell.prototype.clone = function()
{
  var obj = new spell();
  var i = 0;
  for(i in this)
    obj[i] = this[i];
  return obj;
}

spell.prototype.onUseOutsideBattle = function(fromWho, onWho)
{
  this.on_use(fromWho, onWho);
}

spell.prototype.on_use = function(fromWho, onWho)
{
  if(this.has_some(fromWho)) {
    if (!this.limited)
      entities[fromWho].stats.take_mp(this.mp_cost);
    this.use(fromWho, onWho);
  }
}

spell.prototype.onUseInBattle = function(fromWho, onWho)
{
  this.on_use(fromWho, onWho);
}

spell.prototype.has_some = function(fromWho)
{
  if (!this.limited || entities[fromWho].stats.mp > this.mp_cost)
    return true;
  return false;
}

function GiveSpell(spell, who)
{ // spell object as parameter
  var found = false;
  for (var i = 0; i < entities[who].spells.length; ++i)
  {
    if (entities[who].spells[i].name == spell.name) {
      entities[who].spells.amount += spell.amount;
      found = true;
      break;
    }
  }
  if (!found)
    entities[who].spells.push(spell.clone());  
}

/////////////////////////////////////////////////

function entity()
{
  this.name = "entity";
  this.stats = new stats();
  this.weapon = new weapon();
  this.spells = new Array();
  this.type = "monster";
  this.x = 0;
  this.y = 0;
  this.adjusterX = 0;
  this.adjusterY = 0;
  this.animation_name = "normal";
  this.last_drawn = GetTime();
  this.animation_delay = 80;
  this.height = 20;
  this.width = 70;

  // for rotating
  this.angle  =  0.0;
  this.q = 5.0;
  this.r = 5.0;
}


entity.prototype.clone = function()
{
  var obj = new entity();
  var i = 0;
  for(i in this)
    obj[i] = this[i];
    
  obj.stats  = this.stats.clone();
  obj.weapon = this.weapon.clone();
  for (var i = 0; i < this.spells.length; ++i)
    obj.spells[i] = this.spells[i].clone();
  return obj;
}

entity.prototype.position_adjuster = function()
{
  if(this.last_drawn - this.animation_delay < GetTime())
  {
    if (!this.stats.is_defeated())
    {
      this.last_drawn = GetTime();
      if (this.type == "player")
      {
        this.adjusterX = (this.adjusterX == 1 ? 0 : 1)
      }
      else
      if (this.type == "monster")
      {
        this.angle += 0.1;
        this.r = this.q * Math.sin(this.angle / this.q);
        this.adjusterX = this.r * Math.sin(this.angle);
        this.adjusterY = this.r * Math.cos(this.angle);
      }
    }
  }
}


entity.prototype.render = function()
{
  this.position_adjuster();
  // write the entity render method here ^^
  var x = this.x + this.adjusterX;
  var y = this.y + this.adjusterY;
  var font = GetSystemFont()
  if (this.hp < (this.minhp + this.maxhp) / 100 * 20)
    font.setColorMask(CreateColor(255, 0, 0)); 
  GetSystemFont().drawText(x, y, this.name);
  font.setColorMask(CreateColor(255, 255, 255));
}

function Copy_All_Entities()
{
  var c = new Array();
  for (var i = 0; i < entities.length; ++i)
    c.push(entities[i].clone());
  return c;
}


var entities = new Array();
var turnlist = new Array();
var copy_of_entities = new Array();
var battledone = false;
var party_items = new Array();
var party_weapons = new Array();
var party_money = 0;

function CreatePlayerFlik()
{
  var flik = new entity();
  flik.name = "Flik";
  flik.type = "player";
  flik.x = 280;
  flik.y = 100;
  return flik.clone();
}

function InitPlayers()
{  
  var neutral = new entity();
  neutral.type = "neutral";
  neutral.name = "Jim";
  neutral.x = 200;
  neutral.y = 140;

  entities.push(CreatePlayerFlik());
}

function HasBattleEndedYet()
{
  if(ArePlayersAllDead())
     return true;
  if(AreMonstersAllDead())
     return true;
     
  if(battledone)
    return true;
     
  return false;
}

function TotalPlayers()
{
  var totalplayers = 0;
  for(var i = 0; i < entities.length; ++i)
    if(entities[i].type == "player")
      ++totalplayers;
  return totalplayers;
}

function ArePlayersAllDead()
{
  var totaldeadplayers = 0;
  for(var i = 0; i < entities.length; ++i)
    if(entities[i].type == "player")
      if(entities[i].stats.is_defeated())
        ++totaldeadplayers;
        
  if(totaldeadplayers == TotalPlayers())
    return true;
  return false;
}

function TotalMonsters()
{
  var totalmonsters = 0;
  for(var i = 0; i < entities.length; ++i)
    if(entities[i].type == "monster")
      ++totalmonsters;
  return totalmonsters;
}

function AreMonstersAllDead()
{
  var totaldeadmonsters = 0;
  for(var i = 0; i < entities.length; ++i)
    if(entities[i].type == "monster")
      if(entities[i].stats.is_defeated())
        ++totaldeadmonsters;
        
  if(totaldeadmonsters == TotalMonsters())
    return true;
  return false;
}

function RestartBattle()
{
  entities = copy_of_entities;
  copy_of_entities = new Array();
  battle();
}

function ResultDraw()
{
  RestartBattle();
}

function ResultPlayersWon()
{
  DealExp();
  RemoveAllMonsters();
}

function ResultMonstersWon()
{
  // restart battle
  var menu = DefaultMenu(96, 96);
  menu.addText("Restart", function(){ menu.done = true; RestartBattle(); });
  menu.addText("Quit",    function(){ menu.done = true; Exit(); });
  menu.execute();
}

function RemoveAllMonsters()
{
  while(TotalMonsters() > 0)
    for(var i = 0; i < entities.length; ++i)
      if(entities[i].type == "monster")
        entities = entities.slice(0, i).concat(entities.slice(i + 1, entities.length));
}


function ResultRanAway()
{
  RemoveAllMonsters();
}


function DealExp()
{

}

function TakeMoney(amount){ party_money -= amount; }
function GiveMoney(amount) { party_money += amount; }
function DoesHaveMoney(amount) { return (party_money >= amount); }

//////////////////////////////////////////////

function entities_sort_by_spd(a, b)
{
  if (entities[a].stats.spd < entities[b].stats.spd)
    return 1;
  else if (entities[a].stats.spd > entities[b].stats.spd)
    return -1;
  return 0;
}

function GetAliveEntitiesSpeedIndexArray()
{
  var tmp = new Array();
  for(var i = 0; i < entities.length; ++i)
    if(!entities[i].stats.is_defeated())
      tmp.push(i);
  tmp = tmp.sort(entities_sort_by_spd);
  return tmp;
}

function GetAllEntitiesIndexArray()
{
  var tmp = new Array();
  for (var i = 0; i < entities.length; ++i)
    tmp.push(i);
  return tmp;
}


function GetAllDeadEntitiesIndexArray()
{
  var tmp = new Array();
  for (var i = 0; i < entities.length; ++i)
    if (entities[i].stats.is_defeated())
      tmp.push(i);
  return tmp;
}

function GetAllAliveEntitiesIndexArray()
{
  var tmp = new Array();
  for (var i = 0; i < entities.length; ++i)
    if (!entities[i].stats.is_defeated())
      tmp.push(i);
  return tmp;
}


function GetAliveMonstersIndexArray()
{
  var tmp = new Array();
  for(var i = 0; i < entities.length; ++i)
    if(entities[i].type == "monster" && !entities[i].stats.is_defeated())
      tmp.push(i);
  return tmp;
}


function GetAliveNeutralsIndexArray()
{
  var tmp = new Array();
  for(var i = 0; i < entities.length; ++i)
    if(entities[i].type == "neutral" && !entities[i].stats.is_defeated())
      tmp.push(i);
  return tmp;
}

function GetAlivePlayersIndexArray()
{
  var tmp = new Array();
  for(var i = 0; i < entities.length; ++i)
    if(entities[i].type == "player" && !entities[i].stats.is_defeated())
      tmp.push(i);
  return tmp;
}


function GetDeadMonstersIndexArray()
{
  var tmp = new Array();
  for(var i = 0; i < entities.length; ++i)
    if(entities[i].type == "monster" && entities[i].stats.is_defeated())
      tmp.push(i);
  return tmp;
}


function GetDeadNeutralsIndexArray()
{
  var tmp = new Array();
  for(var i = 0; i < entities.length; ++i)
    if(entities[i].type == "neutral" && entities[i].stats.is_defeated())
      tmp.push(i);
  return tmp;
}

function GetDeadPlayersIndexArray()
{
  var tmp = new Array();
  for(var i = 0; i < entities.length; ++i)
    if(entities[i].type == "player" && entities[i].stats.is_defeated())
      tmp.push(i);
  return tmp;
}

//////////////////////////////////////////////


function AttackEntity(attacker, attackee)
{
  for(var i = 0; i < attackee.length; ++i)
  {
    var damage = Math.ceil(entities[attacker].stats.str / entities[attackee[i]].stats.def * entities[attacker].weapon.power / attackee.length);
    entities[attackee[i]].stats.take_hp(damage);
    if (entities[attacker].weapon.limited)
      entities[attacker].weapon.amount -= 1;
  }
}


function DealTurns()
{
  // arrange players / monsters by stats.spd, then give the quickest a turn
  if (turnlist.length <= 0)
  {
    var e = GetAliveEntitiesSpeedIndexArray();
    for (var i = 0; i < e.length; ++i)
      turnlist.push(e[i]);
  }
}

function CreateMainBattleMenu()
{
  var MainBattleMenu = new Menu(64,16);
  var MenuArray = new Array(MainBattleMenu);

  MainBattleMenu.addDefaultKeys(GameUpKey, GameDownKey, GameActionKey, GameEscapeKey);
  MainBattleMenu.defaultMouseSupport(GameMouseStatus, GetGameMouse(), true);
  MainBattleMenu.preRender = function(){ RenderBattle(); GetGameWindowStyle().drawWindow(MainBattleMenu.x, MainBattleMenu.y, MainBattleMenu.getWidth(), MainBattleMenu.getHeight()); } 

  if (entities[turnlist[0]].weapon.getUseableOnIndexArray().length > 0 && (!entities[turnlist[0]].weapon.limited || entities[turnlist[0]].weapon.amount > 0))
    MainBattleMenu.addText("Fight", function(){ CreateFightWhoMenu(MenuArray); });
  if (entities[turnlist[0]].spells.length > 0)
    MainBattleMenu.addText("Magic", function(){ CreateMagicMenu(MenuArray); });
  if (party_items.length > 0)
    MainBattleMenu.addText("Items", function(){ CreateItemMenu(MenuArray); });
  MainBattleMenu.addText("Runaway!", function(){ if(AttemptEscape()) MainBattleMenu.done = true; });

  MainBattleMenu.execute();
  RenderBattle();
}

function AttemptEscape()
{
  var totalplayerspeed = 0;
  var totalmonsterspeed = 0;

  for(var i = 0; i < entities.length; ++i)
  {
    if(entities[i].type == "player" && entities[i].stats.isAbleToAttack())
      totalplayerspeed += entities[i].stats.spd;
    else
      if(entities[i].type == "monster" && entities[i].stats.isAbleToAttack())
        totalmonsterspeed += entities[i].stats.spd;
  }
 
  if(totalplayerspeed >= totalmonsterspeed)
    battledone = true;

  return battledone;
}

function CreateFightWhoMenu(MenuArray)
{
  var FightWhoMenu = new Menu(16, 16);
  MenuArray.push(FightWhoMenu);

 // FightWhoMenu.cutOffHeight = false;
 // FightWhoMenu.cutOffWidth = false;

  FightWhoMenu.defaultMouseSupport(GameMouseStatus, GetGameMouse(), true);

  var q = entities[turnlist[0]].weapon.getUseableOnIndexArray();
  for (var i = 0; i < q.length; ++i)
    FightWhoMenu.addBattlePointer(q[i], function(){ for(var i = 0; i < MenuArray.length; ++i) MenuArray[i].done = true; FightWhoMenu.handleSelection(); AttackEntity(turnlist[0], FightWhoMenu.items[FightWhoMenu.selection].item.target_list); });

  FightWhoMenu.preRender = function(){ 
    RenderBattle();
  }
  FightWhoMenu.escapeable = function(){ return true; }

  MenuArray.push(FightWhoMenu);

  FightWhoMenu.execute();
  RenderBattle();
}

function CreateMagicWhoMenu(MenuArray)
{
  var MagicWhoMenu = new Menu(16,16);
  MenuArray.push(MagicWhoMenu);

  MagicWhoMenu.addDefaultKeys(GameUpKey, GameDownKey, GameActionKey, GameEscapeKey);
  MagicWhoMenu.defaultMouseSupport(GameMouseStatus, GetGameMouse(), true);

  MagicWhoMenu.preRender = function(){ RenderBattle(); } 
  MagicWhoMenu.escapeable = function(){ return true; }

  var which_spell = MenuArray[MenuArray.length - 2].selection;
  var q = entities[turnlist[0]].spells[which_spell].getUseableOnIndexArray();
  for (var i = 0; i < q.length; ++i)
    MagicWhoMenu.addBattlePointer(q[i], function(){ for(var i = 0; i < MenuArray.length; ++i) MenuArray[i].done = true; entities[turnlist[0]].spells[which_spell].onUseInBattle(turnlist[0], MagicWhoMenu.items[MagicWhoMenu.selection].item.target_list); });

  MagicWhoMenu.execute();
  RenderBattle();

}

function CreateMagicMenu(MenuArray)
{
  var MagicMenu = DefaultMenu(16,16);
  MagicMenu.preRender = function(){ RenderBattle(); GetGameWindowStyle().drawWindow(MagicMenu.x, MagicMenu.y, MagicMenu.getWidth(), MagicMenu.getHeight()); } 
  MenuArray.push(MagicMenu);  

  for(var i = 0; i < entities[turnlist[0]].spells.length; ++i)
    MagicMenu.addText(entities[turnlist[0]].spells[i].name + "  " + (entities[turnlist[0]].spells[i].limited ? entities[turnlist[0]].spells[i].mp_cost : ""), function(){ if (entities[turnlist[0]].spells[MagicMenu.selection].has_some(turnlist[0])) CreateMagicWhoMenu(MenuArray); });
  
  MagicMenu.addText("Exit", function(){ MagicMenu.done = true; });
  MagicMenu.execute();
  RenderBattle();
}

function CreateItemWhoMenu(MenuArray)
{
  var ItemWhoMenu = DefaultMenu(16,16);
  ItemWhoMenu.preRender = function(){ RenderBattle(); } 
  MenuArray.push(ItemWhoMenu);
  
  var which_item = MenuArray[MenuArray.length - 2].selection;
  var q = party_items[which_item].getUseableOnIndexArray();
  for (var i = 0; i < q.length; ++i)
    ItemWhoMenu.addBattlePointer(q[i], function(){ for(var i = 0; i < MenuArray.length; ++i) MenuArray[i].done = true; party_items[which_item].onUseInBattle(turnlist[0], ItemWhoMenu.items[ItemWhoMenu.selection].item.target_list); });

  ItemWhoMenu.execute();
  RenderBattle();
}

function CreateItemMenu(MenuArray)
{
  var ItemMenu = new Menu(16,16);
  MenuArray.push(ItemMenu);
    
  ItemMenu.addDefaultKeys(GameUpKey, GameDownKey, GameActionKey, GameEscapeKey);
  ItemMenu.defaultMouseSupport(GameMouseStatus, GetGameMouse(), true);
  ItemMenu.preRender = function(){ RenderBattle(); GetGameWindowStyle().drawWindow(ItemMenu.x, ItemMenu.y, ItemMenu.getWidth(), ItemMenu.getHeight()); } 
  ItemMenu.escapeable = function(){ return true; }

  for(var i = 0; i < party_items.length; ++i)
    ItemMenu.addText(party_items[i].name + "  " + (party_items[i].limited ? party_items[i].amount : ""), function(){ if (party_items[ItemMenu.selection].has_some(turnlist[0])) CreateItemWhoMenu(MenuArray); });
  
  ItemMenu.addText("Exit", function(){ ItemMenu.done = true; });
  ItemMenu.execute();
  RenderBattle();

}


function RenderBattle()
{
  // RenderMap();

  for(var i = 0; i < entities.length; ++i)
    entities[i].render();
    
  BattleDebug();
}

if(TotalPlayers() == 0)
  InitPlayers();

function battle()
{
  if(TotalMonsters() == 0)
    ; // generate random

  copy_of_entities = Copy_All_Entities();

  turnlist = new Array();
  
  while(!HasBattleEndedYet())
  {
    DealTurns();
    RenderBattle();

    if(turnlist.length > 0)
    {
      switch(entities[turnlist[0]].type)
      {
        case "player": CreateMainBattleMenu(); break;

        case "monster":
          AttackEntity(turnlist[0], [GetAlivePlayersIndexArray()[Math.floor(Math.random() * GetAlivePlayersIndexArray().length)]]);
        break;

        case "neutral": 
          // neutral attacking code // they probably shouldn't attack
        break;
      }
      turnlist.shift();
    }
    
    FlipScreen();
  }
  
  battledone = false;
  
  if(ArePlayersAllDead() && AreMonstersAllDead())
    ResultDraw();
  else
    if(ArePlayersAllDead())
      ResultMonstersWon();
    else
      if(!AreMonstersAllDead())
        ResultRanAway();
      else 
      {
        ResultPlayersWon();
        return true;
      }

  return false;
}



function BattleDebug()
{
  var x = 32;
  var y = 150;
  
  // GetGameWindowStyle().drawWindow(x,y, 140, 80);
  
  for(var i = 0; i < entities.length; ++i)
  {
    y += GetGameFont().getHeight();
    GetGameFont().drawText(x,y, entities[i].name + "   " + entities[i].stats.hp + " / " + entities[i].stats.maxhp  + "   " + entities[i].stats.mp + " / " + entities[i].stats.maxmp );
  }
  
  y += GetGameFont().getHeight();
  
  for(var i = 0; i < turnlist.length; ++i)
  {
    GetGameFont().drawText(x,y, entities[turnlist[i]].name);
    x += GetGameFont().getStringWidth(entities[turnlist[i]].name + ", ");
  }
}