
/////////////////////////////////////////////////

function Key()
{
  var m = new item("Key", "Use to open locks", 1, 0);
  return m;
}

function Potion()
{
  var m = new item("Potion", "Use to cure hp", 1, 40);
  m.power = -10;
  m.use = UsePotion;
  return m;
}

function Herb()
{
  var m = new item("Herb", "Cures 10% of hp", 1, 50);
  m.power = -10;
  m.use = UseHerb;
  return m;
}


function Ether()
{
  var m = new item("Ether", "Use to restore mp", 1, 32);
  m.power = -25;
  m.use = UseEther;
  return m;
}

function Exilir()
{
  var m = new item("Exilir", "Restores hp and mp to full", 1, 40);
  m.use = UseExilir;
  return m;
}

function Hex()
{
  var m = new item("Hex", "Kils off ghosts", 1, 44);
  m.useable_outside_battle = false;
  m.canAttackAlivePlayers = false;
  m.canAttackAliveNeutrals = false;
  m.canAttackAliveMonsters = true;
  m.addOrder = new Array("AttackAliveMonsters");
  m.use = UseHex;
  return m;
}

/////////////////////////////////////////////////

function UsePotion(fromWho, onWho)
{
  for (var i = 0; i < onWho.length; ++i)
    entities[onWho[i]].stats.take_hp(this.power / onWho.length);
}

function UseEther(fromWho, onWho)
{
  for (var i = 0; i < onWho.length; ++i)
    entities[onWho[i]].stats.take_mp(this.power / onWho.length);
}


function UseHerb(fromWho, onWho)
{
  for (var i = 0; i < onWho.length; ++i)
    entities[onWho[i]].stats.take_mp(this.power / onWho[i].stats.maxhp / onWho.length);
}


function UseExilir(fromWho, onWho)
{
  for (var i = 0; i < onWho.length; ++i) {
    entities[onWho[i]].stats.take_hp(this.power / onWho.length);
    entities[onWho[i]].stats.take_mp(this.power / onWho.length);
  }
}

function UseHex(fromWho, onWho)
{
  for (var i = 0; i < onWho.length; ++i)
    if (entities[onWho[i]].name == "ghost")
      entities[onWho[i]].stats.hp = 0;
}

///////////////////////////////////////////////////

function ItemsMenu()
{
  var background = GrabImage(0, 0, GetScreenWidth(), GetScreenHeight());
  var menu = DefaultMenu(96, 32);
  
  menu.preRender = function() {
    background.blit(0,0);
    GetGameWindowStyle().drawWindow(menu.x, menu.y, menu.getWidth(), menu.getHeight());
    if ((menu.selection > 0) && (menu.selection < party_items.length - 1))
      GetGameFont().drawText(menu.x, menu.y + menu.height + 16, (party_items[menu.selection].limited ? party_items[menu.selection].amount : ""));
  }

  for(var i = 0; i < party_items.length; ++i) 
    menu.addText(party_items[i].name, function(){ 

    var which_item = menu.selection;
    var who = 0;
    var q = party_items[which_item].getUseableOnIndexArray();

    var background = GrabImage(0, 0, GetScreenWidth(), GetScreenHeight());
    var ItemOnWho = DefaultMenu(32, 32, 64, 96);

    for (var i = 0; i < q.length; ++i)
      ItemOnWho.addText(q[i], function(){ 
        background.blit(0,0);
        if(party_items[which_item].has_some(who)) {     
          party_items[which_item].onUseOutsideBattle(who, q[ItemOnWho.selection]);
        }
        ItemOnWho.done = true;
      });

    ItemOnWho.preRender = function(){
      background.blit(0,0);
      GetGameWindowStyle().drawWindow(ItemOnWho.x, ItemOnWho.y, ItemOnWho.getWidth(), ItemOnWho.getHeight());
      if (menu.selection >= 0 && ItemOnWho.selection < entities.length)
        ShowStats(ItemOnWho.x, ItemOnWho.y + ItemOnWho.height + 32, ItemOnWho.selection);
    }

    ItemOnWho.addText("Exit", function(){ ItemOnWho.done = true; });
    ItemOnWho.execute();
    background.blit(0,0);
  });
  
  menu.addText("Exit", function(){ menu.done = true; });
  menu.execute();
  
  background.blit(0,0);
}

/////////////////////////////////////////////////