EvaluateScript("flik_save.js");
EvaluateScript("flik_menu.js");
EvaluateScript("flik_battle.js");

EvaluateScript("standard.js");
EvaluateScript("monsters.js");
EvaluateScript("weapons.js");
EvaluateScript("items.js");
EvaluateScript("spells.js");
EvaluateScript("stats.js");
EvaluateScript("shop.js");
EvaluateScript("inn.js");
EvaluateScript("movement.js");
EvaluateScript("party_train.js");

EvaluateScript("options.js");
EvaluateScript("groups.js");

EvaluateScript("freddys town.js");
EvaluateScript("nikolas town.js");
EvaluateScript("dungeon.js");

var saveslot = new save_slot();
var event = new Object();
event.equip_a_sword = 0;
event.rescued_freddy = 0;
event.kepler_joined = 0;
event.been_to_freddys_town = 1;
event.been_to_dungeon_prison = 0;
event.been_to_nikolas_town = 0;
event.beaten_nikolas_game = 0;
event.given_boat = 0;
event.freddy_not_afraid_of_dark = 0;

function CreatePlayerKepler()
{
  var kepler = new entity();
  kepler.type = "player";
  kepler.name = "Kepler";
  kepler.x = 270;
  kepler.y = 120;
  kepler.spells.push(Fire(), Cure1());
  return kepler;
}

function CreatePlayerFreddy()
{
  var kepler = new entity();
  kepler.type = "player";
  kepler.name = "Freddy";
  kepler.x = 270;
  kepler.y = 140;
  kepler.spells.push(Cure1(), Fire());
  return kepler;
}

GiveItem(Potion());
GiveItem(Ether());
GiveItem(Exilir());
GiveItem(Hex()); // just some starter items
entities[0].spells.push(Fire(), DeathLevel3());

BindKey(KEY_M, "MapMenu()", "");
BindKey(KEY_ENTER, "OnMapUseWeapon()", "")

function DoesPersonExist(n){
  var p = GetPersonList();
  for (var i = 0; i < p.length; ++i)
    if (n == p[i])
      return true;
  return false;
}

function MapMenu()
{
  var image = GrabImage(0, 0, GetScreenWidth(), GetScreenHeight());
  image.blit(0,0);
  var menu = DefaultMenu(16, 16);
  menu.preRender = function() { image.blit(0,0); GetGameWindowStyle().drawWindow(menu.x, menu.y, menu.getWidth(), menu.getHeight()); }   
  menu.addText("Items",   ItemsMenu);
  menu.addText("Spells",  Spell_Use_Screen);
  menu.addText("Equip",   Weapons_Equip_Screen);
  menu.addText("Stats",   Stats_Screen);
  menu.addText("Options", Options);
  menu.execute();
}

function OnMapUseWeapon()
{
  var base_x = GetPersonX("Flik");
  var base_y = GetPersonY("Flik");

  var direction = GetPersonDirection("Flik");

  if (entities[0].weapon.name == "Bombs") {
    if (!DoesPersonExist("bomb"))
    {
      CreatePerson("bomb", "bomb.rss", true);
      var x = 0;
      var y = 0;
      switch(direction) {
        case "north": y -= 16; break;
        case "south": y += 16; break;
        case "east":  x += 16; break;
        case "west":  x -= 16;  break;
      }

      SetPersonX("bomb", base_x + x);
      SetPersonY("bomb", base_y + y);
      for (var i = 0; i < (8 * 4); ++i)
        QueuePersonCommand("bomb", COMMAND_WAIT, false);
      SetPersonScript("bomb", SCRIPT_COMMAND_GENERATOR, "if (DoesPersonExist('wall')) if (GetPersonX('bomb') >= GetPersonX('wall') && GetPersonX('bomb') <= GetPersonX('wall')) DestroyPerson('wall'); DestroyPerson(GetCurrentPerson())");
    }
  }
}

function game()
{
  var swords = saveslot.read("swords", 0);
  saveslot.write("swords", ++swords);
  saveslot.save();

  CreatePerson("Flik", "pacman.rss", false);
  AttachInput("Flik");
  AttachCamera("Flik");
  AddPartyCharacter("Flik");
  MapEngine("start.rmp", 60);
}

function OnFirstStartMapEngine()
{
  SetLayerRenderer(0, 'ApplyColorMask(CreateColor(0,0,0))');
  var x = saveslot.read("current_x", "");
  var y = saveslot.read("current_y", "");
  var layer = saveslot.read("current_layer", ""); // freddys house.rmp
  var map = saveslot.read("current_map", "freddys house.rmp"); // default map

  var num_of_saves = saveslot.read("num_of_saves", 0);
  if (num_of_saves <= 0)
    GameStarted();
  Warp(x, y, layer, map);
}

///////////////////////////////////////////////

function GameStarted()
{
  Talk("", "Freddy went missing last night...", "middle");
  Talk("", "Someone needs to save him...", "middle");
  Talk("Flik", "I'll try to save him, but I don't even have a sword, so it might be difficult...", "top");
  Talk("", "Oh geeze, go find kepler and get yourself a friking sword!", "middle");
}

function GameCompleted()
{
  Talk("", "Woo, you rock!", "middle");
  RollCredits();
  Exit();
}

function RollCredits()
{
  var x = 0;
  var y = GetScreenHeight() + 10;
  var h = 50; // the height of the text box
  var w = GetScreenWidth();
  var txt = "Flik\n\n\n\n\nhttp://sphere.sf.net/flik/\n\n\nThanks for rescuing Freddy.\n\n\n\n\n\n\n";
  while(y > -h)
  { 
    Rectangle(0,0, GetScreenWidth(), GetScreenHeight(), CreateColor(0,0,0));
    GetSystemFont().drawTextBox(x,y, w, h, 0, txt);
    FlipScreen();
    Delay(75) 
    y -= 1;
  }
}

///////////////////////////////////////////////

function on_enter_dungeon_map()
{
  var p = GetPersonList();
  for (var i = 0; i < p.length; ++i)
  {
    if (p[i].indexOf("chest_") == 0)
      SetPersonDirection(p[i], (saveslot.read(p[i], 0) == 0 ? 'closed' : 'open'));
    else if (p[i].indexOf("switch_") == 0)
      SetPersonDirection(p[i], (saveslot.read(p[i], 0) == 0 ? 'off' : 'on'));
    else if (p[i].indexOf("blue_blob_") == 0)
      if (saveslot.read(p[i], 0) == 1) DestroyPerson(p[i]);
    else if (p[i].indexOf("dungeon_boss_" == 0))
      if (saveslot.read(p[i], 0) == 1) DestroyPerson(p[i]);
  }
}

function on_enter_dungeon_prison_map()
{
  if (event.rescued_freddy == 0)
  {
    CreatePerson("Freddy", "freddy.rss", false);
    SetPersonX("Freddy", 134);
    SetPersonY("Freddy", 86);
    SetPersonScript("Freddy", SCRIPT_ON_ACTIVATE_TALK, "OnTalkDungeonFreddy()");
  }
  event.been_to_dungeon_prison = 1;
}


function on_enter_freddys_town_map()
{
  var p = GetPersonList();
  for (var i = 0; i < p.length; ++i)
  {
    if (p[i].indexOf("townsperson_") == 0)
      SetPersonScript(p[i], SCRIPT_COMMAND_GENERATOR,  "MoveRandomly()");
    else if (p[i] == "gategaurd")
      if (entities[0].weapon.name != "No weapon")
        Move("gategaurd", COMMAND_MOVE_EAST, 1, true);
  }
}

function on_enter_nikolas_town_map()
{
  var p = GetPersonList();
  for (var i = 0; i < p.length; ++i)
  {
    if (p[i].indexOf("townsperson_") == 0)
      SetPersonScript(p[i], SCRIPT_COMMAND_GENERATOR,  "MoveRandomly()");
  }
  event.been_to_nikolas_town = 1;
}

function on_enter_forest_trail_map()
{

}

function ToggleBoat(){
  if (IsInVehicle())
    LeaveBoat();
  else
    EnterBoat();
}

function EnterBoat(){
  if (event.given_boat) {
    for (var i = 0; i < party_train.length; ++i)
      SetPersonX(party_train[i], -100);
    EnterVehicle("boat");
    SetPersonLayer("boat", 0);
  }
  else
  {
    Talk("Kepler", "We can't just steal some guy's boat, Flik!", "middle");
    Talk("Flik", "Aww, rats.", "middle");
  }
}

function LeaveBoat(){
  var x = 0;
  var y = 0;
  switch(GetPersonDirection("boat"))
  {
    case "north": y -= GetTileHeight() * 2; break;
    case "south": y += GetTileHeight() * 2; break;
    case "east":  x += GetTileWidth() * 2; break;
    case "west":  x -= GetTileWidth() * 2; break;
  }


  for (var i = 0; i < party_train.length; ++i) {
    SetPersonX(party_train[i], GetPersonX("boat") + x);
    SetPersonY(party_train[i], GetPersonY("boat") + y);
    SetPersonLayer(party_train[i], GetPersonLayer("boat"));
  }
  ExitVehicle();
}

function on_enter_docks_map(){
  if (!IsInVehicle()) {
    CreatePerson("boat", "boat.rss", false);
    SetPersonX("boat", 96);
    SetPersonY("boat", 448);
    SetPersonScript("boat", SCRIPT_ON_ACTIVATE_TALK, "EnterBoat()");
  }
}

function on_enter_lake_map(){
  if (!IsInVehicle()) {
    CreatePerson("boat", "boat.rss", false);
    SetPersonX("boat", 401);
    SetPersonY("boat", 456);
    SetPersonScript("boat", SCRIPT_ON_ACTIVATE_TALK, "EnterBoat()");
  }
}

function on_leave_docks_map(){
  if (!IsInVehicle())
    DestroyPerson("boat");
}

function on_leave_lake_map(){
  if (!IsInVehicle())
    DestroyPerson("boat");
}

function on_enter_keplers_house_map()
{
  if (event.kepler_joined == 0)
  {
    CreatePerson("Kepler", "kepler.rss", false);
    SetPersonX("Kepler", 219);
    SetPersonY("Kepler", 159);
    SetPersonScript("Kepler", SCRIPT_ON_ACTIVATE_TALK, "OnTalkFreddysTownKepler()");
  }
}

function on_leave_keplers_house_map()
{
  if (event.kepler_joined == 0)
    DestroyPerson("Kepler");
}

function on_leave_dungeon_prison_map()
{
  if (event.rescued_freddy == 0)
    DestroyPerson("Freddy");
}

function on_enter_lake_cave_map(){
  SetLayerRenderer(0, 'ApplyColorMask(CreateColor(0,0,0, 110));')
  if (event.freddy_not_afraid_of_dark == 0)
  {
    Talk("Freddy", "Ahh, but I'm afraid of the dark!", "top");
    Talk("Kepler", "Why do we let him travel with us?", "middle");
    Warp(622, 154, 0, "lake.rmp");
  }
}

function open_chest(chest_id)
{
  SetPersonDirection(chest_id, "open");
  saveslot.write(chest_id, "1");
  return true;
}

function throw_switch(switch_id)
{
  if (GetPersonDirection(switch_id) == 'off')
  {
    SetPersonDirection(switch_id, "on");
    saveslot.write(switch_id, "1");
  }
  else
  {
   SetPersonDirection(switch_id, "off");
   saveslot.write(switch_id, "0");
  }
}


function Warp(x, y, layer, map)
{
  var script = "";

  if (map != undefined && map.length > 0)
    script += "ChangeMap('" + map + "'); ";   

  if (x != undefined && x != "")
    script += "SetPersonX('" + GetInputPerson() + "', '" + x + "'); ";

  if (y != undefined && y != "")
    script += "SetPersonY('" + GetInputPerson() + "', '" + y + "'); ";

  if (layer != undefined && layer != "")
    script += "SetPersonLayer('" + GetInputPerson() + "','" + layer + "'); ";

  // then warp
  SetDelayScript(0, script);
}

function ClearKeyQueue()
{
  while (GetKey()) GetKey();
}

function save_point()
{
  // add yes / no here

  for (var i = 0; i < entities.length; ++i)
    saveslot.write(entities[i].name + ".stats.hp.", entities[i].stats.hp);
  saveslot.write("current_x", GetPersonX("Flik"));
  saveslot.write("current_y", GetPersonY("Flik"));
  saveslot.write("current_map", "dungeon save point.rmp"); // should be GetCurrentMap();
  saveslot.write("num_of_saves", saveslot.read("num_of_saves", 0) + 1);
  saveslot.save();

  ShowText(16, 16, "Saved!");
  FlipScreen();
}

function WarpMenu()
{
  var menu = DefaultMenu(64, 64);

  if (event.been_to_freddys_town)
    menu.addText("Freddys town", function(){ Warp(438, 502, 0, "freddys town.rmp"); menu.done = true; });

  if (event.been_to_dungeon_prison)
    menu.addText("Dungeon prison", function(){ Warp(200, 132, 0, "dungeon prison.rmp"); menu.done = true; });

  if (event.been_to_nikolas_town)
    menu.addText("Nikolas town", function(){ Warp(486, 291, 0, "nikolas town.rmp"); menu.done = true; });
  
  if (menu.items.length <= 0)
    Talk("Flik", "This appears not to do anything, hmm...", "middle");
  else
    menu.execute();
}

function BoulderOnTalkScript()
{
  if (entities[0].weapon.name == "Power Glove")
  {
    var direction = GetPersonDirection(GetInputPerson());
    if (CanMoveInDirection(GetCurrentPerson(), direction, 1))
    {
      switch(direction) {
        case "north": Move(GetCurrentPerson(), COMMAND_MOVE_NORTH, 1, true); break;
        case "south": Move(GetCurrentPerson(), COMMAND_MOVE_SOUTH, 1, true); break;
        case "east":  Move(GetCurrentPerson(), COMMAND_MOVE_EAST,  1, true); break;
        case "west":  Move(GetCurrentPerson(), COMMAND_MOVE_WEST,  1, true); break;
      }
    }
  }
  else
    Talk("Flik", "It's too heavy, it wont budge...", "top");
}