function MoveRandomly(x, y, w, h)
{ // implement x y w h etc later
  var commands = new Array(COMMAND_MOVE_NORTH, COMMAND_MOVE_SOUTH, COMMAND_MOVE_EAST, COMMAND_MOVE_WEST, COMMAND_WAIT);
  var r = Math.floor(Math.random() * commands.length);
  Move(GetCurrentPerson(), commands[r], 1, false);
}

function CanMoveInDirection(name, direction, tiles)
{
  switch (direction) {
    case ("north"): return CanMove(name, COMMAND_MOVE_NORTH, tiles); break;
    case ("south"): return CanMove(name, COMMAND_MOVE_SOUTH, tiles); break;
    case ("east"):  return CanMove(name, COMMAND_MOVE_EAST,  tiles); break;
    case ("west"):  return CanMove(name, COMMAND_MOVE_WEST,  tiles); break;
  }
  return false;
}

function CanMove(name, command, tiles)
{
  switch (command)
  {
    case COMMAND_MOVE_NORTH:
      for (var i = 0; i < GetTileHeight() * tiles; ++i)
        if(IsPersonObstructed(name, GetPersonX(name), GetPersonY(name) + i))
          return false;
      return true;
    break;

    case COMMAND_MOVE_SOUTH:
      for (var i = 0; i < GetTileHeight() * tiles; ++i)
        if(IsPersonObstructed(name, GetPersonX(name), GetPersonY(name) - i))
          return false;
      return true;
    break;

    case COMMAND_MOVE_EAST:
      for (var i = 0; i < GetTileWidth() * tiles; ++i)
        if(IsPersonObstructed(name, GetPersonX(name) + i, GetPersonY(name)))
          return false;
      return true;
    break;

    case COMMAND_MOVE_WEST:
      for (var i = 0; i < GetTileWidth() * tiles; ++i)
        if(IsPersonObstructed(name, GetPersonX(name) - i, GetPersonY(name)))
          return false;
      return true;
    break;

    case COMMAND_WAIT:
      return true; // duh ^_^
    break;
  }
  return false;
}


function Move(name, command, tiles, immediate)
{
  switch (command)
  {
    case COMMAND_MOVE_NORTH:
      QueuePersonCommand(name, COMMAND_FACE_NORTH, immediate);
      for (var i = 0; i < GetTileHeight() * tiles; ++i)
        QueuePersonCommand(name, command, false);
    break;

    case COMMAND_MOVE_SOUTH:
      QueuePersonCommand(name, COMMAND_FACE_SOUTH, immediate);
      for (var i = 0; i < GetTileHeight() * tiles; ++i)
        QueuePersonCommand(name, command, false);
    break;

    case COMMAND_MOVE_EAST:
      QueuePersonCommand(name, COMMAND_FACE_EAST, immediate);
      for (var i = 0; i < GetTileWidth() * tiles; ++i)
        QueuePersonCommand(name, command, false);
    break;

    case COMMAND_MOVE_WEST:
      QueuePersonCommand(name, COMMAND_FACE_WEST, immediate);
      for (var i = 0; i < GetTileWidth() * tiles; ++i)
        QueuePersonCommand(name, command, false);
    break;

    case COMMAND_WAIT:
      for (var i = 0; i < GetTileWidth() * tiles; ++i)
        QueuePersonCommand(name, command, false);
    break;

  }
}