
/////////////////////////////////////////////////


function CustomiseMouse()
{
  var background = GrabImage(0,0, GetScreenWidth(), GetScreenHeight());
  var menu = new Menu(120, 32);
  menu.addDefaultKeys(GameUpKey, GameDownKey, GameActionKey, GameEscapeKey);
  var mouse_images_filenames = new Array("mouse.png", "mouse1.png");
  var choosen_image_index = 0;

  for (var i = 0; i < mouse_images_filenames.length; ++i)
    menu.addImage(LoadImage(mouse_images_filenames[i]), function(){ choosen_image_index = menu.selection; GameMouse = LoadImage(mouse_images_filenames[choosen_image_index]); menu.mouse = GetGameMouse(); });
 
  menu.addText("Mouse Support " + (GameMouseStatus ?  "on" : "off"), function(){
    GameMouseStatus = (GameMouseStatus ? false : true);
    menu.items[menu.items.length - mouse_images_filenames.length].item.name = "Mouse Support " + (GameMouseStatus ? "on" : "off");
    menu.mouseSupport = GameMouseStatus;
  });
  
  menu.addText("Exit", function(){ menu.done = true; });
  
  menu.defaultMouseSupport(GameMouseStatus, GetGameMouse(), true);
  menu.preRender = function(){
    background.blit(0,0);
    GetGameWindowStyle().drawWindow(menu.x, menu.y, menu.getWidth(), menu.getHeight());
  }
  
  menu.escapeable = function(){ return true; }

  menu.execute();
  background.blit(0,0);
}

function CustomiseArrow()
{
  var background = GrabImage(0,0, GetScreenWidth(), GetScreenHeight());
  var menu = new Menu(120, 32);
  var arrow_images = new Array("arrow.png", "arrow1.png", "arrow2.png");

  for (var i = 0; i < arrow_images.length; ++i)
    menu.addImage(LoadImage(arrow_images[i]), function(){ GameArrow = LoadImage(arrow_images[menu.selection]); });
  menu.addText("Exit", function(){ menu.done = true; });
  
  menu.defaultMouseSupport(GameMouseStatus, GetGameMouse(), true);
  menu.preRender = function(){
    background.blit(0,0);
    GetGameWindowStyle().drawWindow(menu.x, menu.y, menu.getWidth(), menu.getHeight());
  }
  menu.escapeable = function(){ return true; }
  menu.execute();
  background.blit(0,0);
}

function CustomiseWindowStyle()
{
  var background = GrabImage(0,0, GetScreenWidth(), GetScreenHeight());
  var menu = new Menu(120, 32);

  var WindowStyleListFilenames = new Array("system.rws", "unicorn.rws", "serpent.rws");
  var window_style_index = 0;
  // new Array(LoadWindowStyle("system.rws"), LoadWindowStyle("unicorn.rws"), LoadWindowStyle("serpent.rws"));

  menu.addText("System", function(){ window_style_index = menu.selection; GameWindowStyle = LoadWindowStyle(WindowStyleListFilenames[window_style_index]); });
  menu.addText("Unicorn", function(){ window_style_index = menu.selection; GameWindowStyle = LoadWindowStyle(WindowStyleListFilenames[window_style_index]);  });
  menu.addText("Serpent", function(){ window_style_index = menu.selection; GameWindowStyle = LoadWindowStyle(WindowStyleListFilenames[window_style_index]);  });

  menu.addText("Exit", function(){ menu.done = true; });
  
  menu.defaultMouseSupport(GameMouseStatus, GetGameMouse(), true);
  menu.preRender = function(){
    background.blit(0,0);
    menu.handleSelection();
    GetGameWindowStyle().drawWindow(menu.x, menu.y, menu.getWidth(), menu.getHeight());
  }
  
  menu.escapeable = function(){ return true; }
  menu.execute();
  background.blit(0,0);
}


function GetColorList()
{
  var system = { name: "SYSTEM", color: CreateColor(0,255,255)   };
  var white =  { name: "WHITE",  color: CreateColor(255,255,255) };
  var blue =   { name: "BLUE",   color: CreateColor(0,0,255)     };
  var red =    { name: "RED",    color: CreateColor(255,0,0)     };

  return new Array(system, white, blue, red);
}

function CustomiseFont()
{
  var background = GrabImage(0,0, GetScreenWidth(), GetScreenHeight());
  var menu = new Menu(120, 32);

  var colorlist = GetColorList();
  var currentcolor = 0
  var currentnoncolor = 1;

  var text = "The big brown fox jumped over the lazy dog.";
  var fonts = new Array("system.rfn", "mike.rfn");

  menu.addText("System", function(){ GameFont = LoadFont(fonts[menu.selection]); });
  menu.addText("Mike", function(){ GameFont = LoadFont(fonts[menu.selection]);   }); 

  menu.addText("Active Color: " + colorlist[currentcolor].name, function(){ if(++currentcolor > colorlist.length - 1) currentcolor = 0; menu.items[menu.items.length - 3].item.name = "Active Color: " + colorlist[currentcolor].name; ActiveColor = colorlist[currentcolor].color; });
  menu.addText("Nonactive Color: " + colorlist[currentnoncolor].name, function(){ if(++currentnoncolor > colorlist.length - 1) currentnoncolor = 0; menu.items[menu.items.length - fonts.length].item.name = "Nonactive Color: " + colorlist[currentnoncolor].name;  NonactiveColor = colorlist[currentnoncolor].color; });
  menu.addText("Exit", function(){ menu.done = true; }, GetGameFont(), NonactiveColor, ActiveColor, GetGameArrow());
  
  menu.defaultMouseSupport(GameMouseStatus, GetGameMouse(), true);
  menu.preRender = function(){
    background.blit(0,0);
    GetGameWindowStyle().drawWindow(menu.x, menu.y, menu.getWidth() + (25), menu.getHeight());
    GetGameFont().drawTextBox(16,150, GetScreenWidth() - 16, GetScreenHeight() - 150, 0, text);
  }
  
  menu.escapeable = function(){ return true; }
  menu.execute();
  
  
  background.blit(0,0);
}


function CustomiseKeys()
{
  var background = GrabImage(0,0, GetScreenWidth(), GetScreenHeight());
  var menu = new Menu(120, 32);
  menu.addDefaultKeys(GameUpKey, GameDownKey, GameActionKey, GameEscapeKey);

  menu.addText("Action: " + GameActionKey , function(){ ClearKeyQueue(); GameActionKey = GetKey(); menu.items[0].item.name = "Action: " + GameActionKey;  });
  menu.addText("Menu: " + GameMenuKey, function(){ ClearKeyQueue(); GameMenuKey = GetKey(); menu.items[1].item.name = "Menu: " + GameMenuKey;  }); 

  menu.addText("Up: " + GameUpKey,         function(){ ClearKeyQueue(); GameUpKey     = GetKey(); menu.items[menu.selection].item.name = "Up: "     + GameUpKey;     }); 
  menu.addText("Right: " + GameRightKey,   function(){ ClearKeyQueue(); GameRightKey  = GetKey(); menu.items[menu.selection].item.name = "Right: "  + GameRightKey;  }); 
  menu.addText("Down: " + GameDownKey,     function(){ ClearKeyQueue(); GameDownKey   = GetKey(); menu.items[menu.selection].item.name = "Down: "   + GameDownKey;   }); 
  menu.addText("Left: " + GameLeftKey,     function(){ ClearKeyQueue(); GameLeftKey   = GetKey(); menu.items[menu.selection].item.mame = "Left: "   + GameLeftKey;   }); 
  menu.addText("Escape: " + GameEscapeKey, function(){ ClearKeyQueue(); GameEscapeKey = GetKey(); menu.items[menu.selection].item.name = "Escape: " + GameEscapeKey; }); 

  menu.addText("Default keys ", function(){
  
    GameActionKey = KEY_ENTER;
    GameMenuKey = KEY_S;
    GameUpKey = KEY_UP;
    GameRightKey = KEY_RIGHT;
    GameDownKey = KEY_DOWN;
    GameLeftKey = KEY_LEFT;
    GameEscapeKey = KEY_ESCAPE;
    
    menu.items[0].item.name = "Action: " + GameActionKey;
    menu.items[1].item.name = "Menu: " + GameMenuKey;
    menu.items[2].item.name = "Up: " + GameUpKey;
    menu.items[3].item.name = "Right: " + GameRightKey;
    menu.items[4].item.name = "Down: " + GameDownKey;
    menu.items[5].item.name = "Left: " + GameLeftKey;
    menu.items[6].item.name = "Escape: " + GameEscapeKey;

  }, GetGameFont(), NonactiveColor, ActiveColor, GetGameArrow()); 

  menu.addText("Exit", function(){ menu.done = true; });
  
  menu.defaultMouseSupport(GameMouseStatus, GetGameMouse(), true);
  menu.preRender = function(){
    background.blit(0,0);
    GetGameWindowStyle().drawWindow(menu.x, menu.y, menu.getWidth(), menu.getHeight());
  }
  
  menu.escapeable = function(){ return true; }
  menu.execute();

  /* with(saveslot)
  {
    write("GameActionKey", GameActionKey);
    write("GameMenuKey", GameMenuKey);
    write("GameTalkKey", GameTalkKey);
    write("GameUpKey", GameUpKey);
    write("GameRightKey", GameRightKey);
    write("GameDownKey", GameDownKey);
    write("GameLeftKey", GameLeftKey);
    write("GameEscapeKey", GameEscapeKey);
  } */

  // activate changes...
  // BindGameKeys();
  
  background.blit(0,0);

}


//////////////////////////////////////////////////////////////////////////////

function Options(){
  var background = GrabImage(0,0, GetScreenWidth(), GetScreenHeight());
  
  var menu = new Menu(96, 16);
  menu.addText("Mouse", CustomiseMouse, GetGameFont(), NonactiveColor, ActiveColor, GetGameArrow());
  menu.addText("Arrow", CustomiseArrow, GetGameFont(), NonactiveColor, ActiveColor, GetGameArrow());
  menu.addText("Window", CustomiseWindowStyle, GetGameFont(), NonactiveColor, ActiveColor, GetGameArrow());
  menu.addText("Font", CustomiseFont, GetGameFont(), NonactiveColor, ActiveColor, GetGameArrow());
  menu.addText("Keys", CustomiseKeys, GetGameFont(), NonactiveColor, ActiveColor, GetGameArrow());
  menu.addText("Exit", function(){ menu.done = true; }, GetGameFont(), NonactiveColor, ActiveColor, GetGameArrow());

  menu.preRender = function(){
    menu.defaultMouseSupport(GameMouseStatus, GetGameMouse(), true);
    menu.addDefaultKeys(GameUpKey, GameDownKey, GameActionKey, GameEscapeKey);
    background.blit(0,0);
    GetGameFont().drawTextBox(16,200, GetScreenWidth() - 16, GetScreenHeight() - 200, 0, "Some features may not become fully active until you restart.");
    GetGameWindowStyle().drawWindow(menu.x, menu.y, menu.getWidth(), menu.getHeight());
  }

  menu.escapeable = function(){ return true; }
  menu.execute();
  background.blit(0,0);  
}