///////////////////////////////////////////////////
// Implemation of some weapons...                //
///////////////////////////////////////////////////

function No_Weapon()
{
  var w = new weapon();
  w.name = "No Weapon";
  w.addOrder = new Array("AttackAliveMonsters", "AttackAlivePlayers");
  return w;
}

function Rusty_Sword()
{
  var w = new weapon();
  w.name = "Rusty Sword";
  w.power = 2;
  w.cost = 15;
  w.desc = "Very old rusty sword";
  return w;
}

function Betrayal_Sword()
{
  var w = new weapon();
  w.name = "Betrayal Sword";
  w.power = 4;
  w.cost = 75;
  w.desc = "Allows you to attack your own team";
  w.addOrder = new Array("AttackAlivePlayers", "AttackAllAlivePlayers",  "AttackAliveNeutrals", "AttackAllAliveNeutrals", "AttackAliveMonsters", "AttackAllAliveMonsters");
  return w;
}

function Power_Glove()
{
  var w = new weapon();
  w.name = "Power Glove";
  w.power = 4;
  w.cost = 500;
  w.desc = "Can also push boulders when equipped.";
  return w;
}

function Axe()
{
  var w = new weapon();
  w.name = "Axe";
  w.power = 8;
  w.cost = 150;
  w.desc = "Brand shiny new axe weapon";
  return w;
}

function Bomb()
{
  var w = new weapon();
  w.name = "Bombs";
  w.amount = 50;
  w.cost = 50;
  w.power = 6;
  w.limited = true;
  w.desc = "Blow up walls and enemies";
  return w;
}

function BowAndArrows()
{
  var w = new weapon();
  w.name = "Bow and arrows";
  w.amount = 200;
  w.limited = true;
  w.power = 7;
  return w;
}

///////////////////////////////////////////////////

function Equip_Who_Screen()
{
  var menu = DefaultMenu(96, 16);
  var background = GrabImage(0, 0, GetScreenWidth(), GetScreenHeight());
  menu.preRender = function(){
    background.blit(0,0);
    GetGameWindowStyle().drawWindow(menu.x, menu.y, menu.getWidth(), menu.getHeight());
  }

  for (var i = 0; i < entities.length; ++i)
    if (entities[i].type == "player")
      menu.addText(entities[i].name, 
      function(){ 
        for (var j = 0; j < entities.length; ++j)
          if (entities[j].type == "player" && j == menu.selection)
          {
            menu.done = true;
            return menu.selection;
          }
      });  

  return menu.execute();
}

function Weapons_Equip_Screen()
{
  var background = GrabImage(0, 0, GetScreenWidth(), GetScreenHeight());
  var who = Equip_Who_Screen();

  if (who >= 0)
  {
    var menu = DefaultMenu(48, 32, GetScreenWidth() - 48 - 16, GetScreenHeight() - 96);

    menu.escapeable = function(){ return true; }
    menu.preRender = function(){
      background.blit(0,0);
      for (var j = 0; j < entities.length; ++j)
        if (entities[j].type == "player")
        {
          if (j == who)
            GetGameFont().setColorMask(ActiveColor);
          GetGameFont().drawText(32, 16 + j * GetGameFont().getHeight(), entities[j].name);
          GetGameFont().setColorMask(NonactiveColor);
        }

      GetGameWindowStyle().drawWindow(menu.x, menu.y, menu.width, menu.height);
      GetGameWindowStyle().drawWindow(menu.x, menu.y + menu.height, menu.width, 48);
   
      var str = "";
      if (party_weapons.length > 0 && menu.selection != menu.items.length - 1)
      {
        str = party_weapons[menu.selection].name + (party_weapons[menu.selection].desc != "" ? " : " + party_weapons[menu.selection].desc : "") +
        (party_weapons[menu.selection].limited ? " #" + party_weapons[menu.selection].amount : "");
        GetGameFont().drawTextBox(menu.x, menu.y + menu.height, menu.width, 48, 0,  str);
      }
    }
    for (var i = 0; i < party_weapons.length; ++i)
      menu.addText(party_weapons[i].name, function() { party_weapons[menu.selection].on_equip(who); menu.done = true; });

    menu.addText("Exit", function(){ menu.done = true; });
    menu.execute();
  }
}